Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell

Namespace WinPhoneFtp.DemoApp

	Partial Public Class Connect
		Inherits PhoneApplicationPage

		Public Sub New()

			InitializeComponent()

		End Sub

		Protected Overrides Sub OnNavigatingFrom(ByVal e As NavigatingCancelEventArgs)

			txtFtpServerIp.IsEnabled = True
			txtPortNumber.IsEnabled = True
			SystemTray.ProgressIndicator = Nothing
			MyBase.OnNavigatingFrom(e)

		End Sub

		Private async Sub appbarbtnConnect_Click(ByVal sender As Object, ByVal e As EventArgs)

			If txtFtpServerIp.Text.Equals(String.Empty) Then

				MessageBox.Show("FTP Server IP/Hostname cannot be empty", "FTP Demo App", MessageBoxButton.OK)
				txtFtpServerIp.Focus()
                Exit Sub

			End If

			Dim PortNumber As Int32 = 0
			If txtPortNumber.Text.Equals(String.Empty) OrElse (Not Int32.TryParse(txtPortNumber.Text, PortNumber)) Then

				MessageBox.Show("Either the port number is empty or is not a valid port number", "FTP Demo App", MessageBoxButton.OK)
				txtPortNumber.Focus()
                Exit Sub

			End If

			txtFtpServerIp.IsEnabled = False
			txtPortNumber.IsEnabled = False
			SystemTray.ProgressIndicator = New ProgressIndicator With {.IsIndeterminate = True, .Text = "Connecting . . ."}
			await (TryCast(App.Current, App)).ConnectToFtpServer(txtFtpServerIp.Text, txtPortNumber.Text)

		End Sub

	End Class

End Namespace
