Imports System.Linq
Imports System.Net
Imports System.IO
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports System.Windows.Threading
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports Windows.Storage

Namespace WinPhoneFtp.DemoApp

	Partial Public Class FileUpload
		Inherits PhoneApplicationPage

		Public Sub New()

			InitializeComponent()

		End Sub

		Private uploadFilename As String = String.Empty
		Private timer As DispatcherTimer = Nothing
		Private uploadedChunckSize As UInt32 = 0
		Private totalUploadedSize As UInt32 = 0

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)

			If Me.NavigationContext.QueryString.Count.Equals(1) AndAlso Me.NavigationContext.QueryString.ContainsKey("File") Then

				uploadFilename = Me.NavigationContext.QueryString("File")
				txtblkUploadFilename.Text = String.Format("File to upload: {0}", uploadFilename)

			Else

				MessageBox.Show("Invalid Page Navigation detected", "FTP Demo App", MessageBoxButton.OK)
				Me.NavigationService.Navigate(New Uri("/PhoneDirectoryBrowser.xaml", UriKind.Relative))

			End If
			MyBase.OnNavigatedTo(e)

		End Sub

		Private async Sub btnUploadFile_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

			btnUploadFile.IsEnabled = False
			SystemTray.SetProgressIndicator(Me, New ProgressIndicator With {.IsIndeterminate = True, .Text = "Uploading file over FTP", .IsVisible = True})
			timer = New DispatcherTimer With {.Interval = TimeSpan.FromSeconds(1)}
			AddHandler timer.Tick, AddressOf timer_Tick
			AddHandler TryCast(App.Current, App).Client.FtpFileUploadSucceeded, AddressOf Client_FtpFileUploadSucceeded
			AddHandler TryCast(App.Current, App).Client.FtpFileUploadFailed, AddressOf Client_FtpFileUploadFailed
			AddHandler TryCast(App.Current, App).Client.FtpFileTransferProgressed, AddressOf Client_FtpFileTransferProgressed
            Dim localFile As StorageFile = Await (TryCast(App.Current, App)).PhoneCurrentWorkingDirectory.Peek.GetFileAsync(uploadFilename)
            Await (TryCast(App.Current, App)).Client.UploadFileAsync(Await localFile.OpenStreamForReadAsync, uploadFilename)
			timer.Start()

		End Sub

		Private Sub Client_FtpFileTransferProgressed(ByVal sender As Object, ByVal e As FtpService.FtpFileTransferProgressedEventArgs)

			Me.uploadedChunckSize += e.BytesTransferred
			Me.totalUploadedSize += e.BytesTransferred

		End Sub

		Private Sub Client_FtpFileUploadFailed(ByVal sender As Object, ByVal e As FtpService.FtpFileTransferFailedEventArgs)

			Me.Dispatcher.BeginInvoke(Sub()

				btnUploadFile.IsEnabled = True
				SystemTray.ProgressIndicator = Nothing
				timer.Stop()
				MessageBox.Show(String.Format("Unable to upload file. Reason: {0}", e.FileTransferFailReason), "FTP Demo App", MessageBoxButton.OK)
				Me.NavigationService.Navigate(New Uri("/PhoneDirectoryBrowser.xaml", UriKind.Relative))

			End Sub)

		End Sub

		Private Sub Client_FtpFileUploadSucceeded(ByVal sender As Object, ByVal e As FtpService.FtpFileTransferEventArgs)

			Me.Dispatcher.BeginInvoke(Sub()

				btnUploadFile.IsEnabled = True
				SystemTray.ProgressIndicator = Nothing
				timer.Stop()
				MessageBox.Show("File uploaded successfully", "FTP Demo App", MessageBoxButton.OK)
				Me.NavigationService.Navigate(New Uri("/PhoneDirectoryBrowser.xaml", UriKind.Relative))

			End Sub)

		End Sub

		Private Sub timer_Tick(ByVal sender As Object, ByVal e As EventArgs)

			Me.uploadedChunckSize = 0
			If SystemTray.ProgressIndicator IsNot Nothing Then

				SystemTray.ProgressIndicator.Text = String.Format("{0} KB uploaded", Convert.ToSingle(totalUploadedSize \ 1024).ToString("F2"))

			End If

		End Sub

		Private Sub appbarmnuDisconnect_Click(ByVal sender As Object, ByVal e As EventArgs)

			Me.NavigationService.Navigate(New Uri("/Disconnect.xaml", UriKind.Relative))

		End Sub

	End Class

End Namespace
