Imports System.Collections.ObjectModel
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell

Namespace WinPhoneFtp.DemoApp

	Partial Public Class FtpDirectoryBrowser
		Inherits PhoneApplicationPage

		Public Sub New()

			InitializeComponent()

		End Sub

		Protected Overrides Sub OnNavigatingFrom(ByVal e As NavigatingCancelEventArgs)

			RemoveHandler TryCast(App.Current, App).Client.FtpDirectoryListed, AddressOf Client_FtpDirectoryListed

		End Sub

		Protected async Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)

			Do While Me.NavigationService.CanGoBack

				Me.NavigationService.RemoveBackEntry()

			Loop

			AddHandler TryCast(App.Current, App).Client.FtpDirectoryListed, AddressOf Client_FtpDirectoryListed
            Await (TryCast(App.Current, App)).Client.GetDirectoryListingAsync
			MyBase.OnNavigatedTo(e)

		End Sub

		Protected async Overrides Sub OnBackKeyPress(ByVal e As System.ComponentModel.CancelEventArgs)

			Select Case MessageBox.Show("Do you want to disconnect and exit", "FTP Demo App", MessageBoxButton.OKCancel)

				Case MessageBoxResult.OK
                    Await (TryCast(App.Current, App)).Client.DisconnectAsync

				Case MessageBoxResult.Cancel
					e.Cancel = True

			End Select

			MyBase.OnBackKeyPress(e)

		End Sub

		Private Sub Client_FtpDirectoryListed(ByVal sender As Object, ByVal e As FtpService.FtpDirectoryListedEventArgs)

            Me.Dispatcher.BeginInvoke(Sub()

                                          If e.GetFilenames().Length > 0 Then

                                              txtblkNoFiles.Visibility = System.Windows.Visibility.Collapsed
                                              lstFiles.Visibility = System.Windows.Visibility.Visible
                                              lstFiles.ItemsSource = e.GetFilenames()

                                          Else

                                              txtblkNoFiles.Visibility = System.Windows.Visibility.Visible
                                              lstFiles.Visibility = System.Windows.Visibility.Collapsed

                                          End If
                                          Dim dirList As New List(Of String)
                                          If Not (TryCast(App.Current, App)).ServerCurrentWorkingDirectory.Equals("/") Then

                                              dirList.Add("One Folder Up")

                                          End If
                                          dirList.AddRange(e.GetDirectories())
                                          lstDirectories.ItemsSource = dirList

                                      End Sub)

		End Sub

		Private Sub appbarmnuDisconnect_Click(ByVal sender As Object, ByVal e As EventArgs)

			Me.NavigationService.Navigate(New Uri("/Disconnect.xaml", UriKind.Relative))

		End Sub

		Private async Sub txtblkDirName_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            If (TryCast(sender, TextBlock)).DataContext.ToString.Equals("One Folder Up") Then

                Await (TryCast(App.Current, App)).Client.ChangeWorkingDirectoryAsync("..")

            Else

                Await (TryCast(App.Current, App)).Client.ChangeWorkingDirectoryAsync((TryCast(sender, TextBlock)).DataContext.ToString)

            End If
            Await (TryCast(App.Current, App)).Client.GetDirectoryListingAsync

		End Sub

		Private Sub txtblkFileName_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            Me.NavigationService.Navigate(New Uri(String.Format("/FileDownload.xaml?File={0}", (TryCast(sender, TextBlock)).DataContext.ToString), UriKind.Relative))

		End Sub

		Private Sub appbarbtnUploadFile_Click(ByVal sender As Object, ByVal e As EventArgs)

			Me.NavigationService.Navigate(New Uri("/PhoneDirectoryBrowser.xaml", UriKind.Relative))

		End Sub

	End Class

End Namespace
