Imports System.Linq
Imports System.Net
Imports System.Threading.Tasks
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports Windows.Storage

Namespace WinPhoneFtp.DemoApp

	Partial Public Class PhoneDirectoryBrowser
		Inherits PhoneApplicationPage

		Public Sub New()

			InitializeComponent()

		End Sub

		Protected async Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)

            Await RefreshFileSystemListAsync((TryCast(App.Current, App)).PhoneCurrentWorkingDirectory.Peek)
			MyBase.OnNavigatedTo(e)

		End Sub

		Private async Function RefreshFileSystemListAsync(ByVal currentFolder As StorageFolder) As Task

            Dim files As List(Of String) = (
                From file As StorageFile In Await currentFolder.GetFilesAsync
                Select file.Name).ToList

			If files.Count.Equals(0) Then

				lstFiles.Visibility = System.Windows.Visibility.Collapsed
				txtblkNoFiles.Visibility = System.Windows.Visibility.Visible
				lstFiles.ItemsSource = Nothing

			Else

				lstFiles.Visibility = System.Windows.Visibility.Visible
				txtblkNoFiles.Visibility = System.Windows.Visibility.Collapsed
				lstFiles.ItemsSource = files

			End If

            Dim dirList As List(Of String) = (
                From directory As StorageFolder In Await currentFolder.GetFoldersAsync
                Select directory.Name).ToList
			If Not Windows.Storage.ApplicationData.Current.LocalFolder.Name.Equals(currentFolder.Name) Then

                dirList.Insert(0, "One Folder Up")

			End If

			If dirList.Count.Equals(0) Then

				lstDirectories.Visibility = System.Windows.Visibility.Collapsed
				txtblkNoDirectories.Visibility = System.Windows.Visibility.Visible
				lstDirectories.ItemsSource = Nothing

			Else

				lstDirectories.Visibility = System.Windows.Visibility.Visible
				txtblkNoDirectories.Visibility = System.Windows.Visibility.Collapsed
				lstDirectories.ItemsSource = dirList

			End If

		End Function

		Private async Sub txtblkDirName_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            Dim dirName As String = (TryCast(sender, TextBlock)).DataContext.ToString
            If dirName.Equals("One Folder Up") Then

                TryCast(App.Current, App).PhoneCurrentWorkingDirectory.Pop()

            Else

                TryCast(App.Current, App).PhoneCurrentWorkingDirectory.Push(Await (TryCast(App.Current, App)).PhoneCurrentWorkingDirectory.Peek.GetFolderAsync((TryCast(sender, TextBlock)).DataContext.ToString))

            End If
            Await RefreshFileSystemListAsync((TryCast(App.Current, App)).PhoneCurrentWorkingDirectory.Peek)

		End Sub

		Private Sub txtblkFileName_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            Me.NavigationService.Navigate(New Uri(String.Format("/FileUpload.xaml?File={0}", (TryCast(sender, TextBlock)).DataContext.ToString), UriKind.Relative))

		End Sub

	End Class

End Namespace
