Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.IO
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports Windows.Storage
Imports Windows.System
Imports System.IO.IsolatedStorage
Imports WinPhoneFtp.FtpService
Imports System.Threading.Tasks
Imports Windows.Networking.Sockets
Imports Windows.UI.Core

Namespace WinPhoneFtp.UserExperience

    Partial Public Class FtpTest
        Inherits PhoneApplicationPage

        Public Sub New()

            InitializeComponent()

        End Sub

        Private ftpClient As FtpClient = Nothing
        Private logger As Logger = Nothing

        Private Async Sub btnLogin_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            logger = Logger.GetDefault(Me.Dispatcher)
            lstLogs.ItemsSource = logger.Logs
            ftpClient = New FtpClient(txtIp.Text, Me.Dispatcher)
            'ftpClient = new PqaFtpClient(txtIp.Text)
            AddHandler ftpClient.FtpConnected, AddressOf ftpClient_FtpConnected
            AddHandler ftpClient.FtpDisconnected, AddressOf ftpClient_FtpDisconnected
            AddHandler ftpClient.FtpAuthenticationSucceeded, AddressOf ftpClient_FtpAuthenticationSucceeded
            AddHandler ftpClient.FtpAuthenticationFailed, AddressOf ftpClient_FtpAuthenticationFailed
            AddHandler ftpClient.FtpDirectoryChangedFailed, AddressOf ftpClient_FtpDirectoryChangedFailed
            AddHandler ftpClient.FtpDirectoryChangedSucceded, AddressOf ftpClient_FtpDirectoryChangedSucceded
            AddHandler ftpClient.FtpPresentWorkingDirectoryReceived, AddressOf ftpClient_FtpPresentWorkingDirectoryReceived
            AddHandler ftpClient.FtpFileUploadSucceeded, AddressOf ftpClient_FtpFileUploadSucceeded
            AddHandler ftpClient.FtpFileDownloadSucceeded, AddressOf ftpClient_FtpFileDownloadSucceeded
            AddHandler ftpClient.FtpFileUploadFailed, AddressOf ftpClient_FtpFileUploadFailed
            AddHandler ftpClient.FtpFileDownloadFailed, AddressOf ftpClient_FtpFileDownloadFailed
            AddHandler ftpClient.FtpDirectoryListed, AddressOf ftpClient_FtpDirectoryListed
            AddHandler ftpClient.FtpFileTransferProgressed, AddressOf ftpClient_FtpFileTransferProgressed
            Await ftpClient.ConnectAsync

        End Sub

        Private Sub ftpClient_FtpDisconnected(ByVal sender As Object, ByVal e As FtpDisconnectedEventArgs)

            logger.AddLog(String.Format("FTP Disconnected. Reason: {0}", e.DisconnectReason))

        End Sub

        Private Sub ftpClient_FtpFileTransferProgressed(ByVal sender As Object, ByVal e As FtpFileTransferProgressedEventArgs)

            'logger.AddLog(String.Format("File {0}, Data Transferred: {1}", e.IsUpload ? "Upload" : "Download", e.BytesTransferred))

        End Sub

        Private Sub ftpClient_FtpDirectoryListed(ByVal sender As Object, ByVal e As FtpDirectoryListedEventArgs)

            logger.AddLog("Directory Listing")

            For Each filename As String In e.GetFilenames()

                logger.AddLog("file: " & filename)

            Next filename

            For Each dir As String In e.GetDirectories()

                logger.AddLog("directory: " & dir)

            Next dir

        End Sub

        Private Async Sub btnFtp_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            If txtCmd.Text.StartsWith("STOR") Then

                logger.Logs.Clear()
                Dim Filename As String = txtCmd.Text.Split(New Char() {" "c, "/"c}, StringSplitOptions.RemoveEmptyEntries).Last
                Dim file As StorageFile = Await Windows.Storage.ApplicationData.Current.LocalFolder.GetFileAsync(txtCmd.Text.Split(New Char() {" "c}, StringSplitOptions.RemoveEmptyEntries)(1))
                Await ftpClient.UploadFileAsync(Await file.OpenStreamForReadAsync, "video2.mp4")
                Exit Sub

            End If

            If txtCmd.Text.StartsWith("RETR") Then

                logger.Logs.Clear()
                Dim Filename As String = txtCmd.Text.Split(New Char() {" "c, "/"c}, StringSplitOptions.RemoveEmptyEntries).Last()
                Dim file As StorageFile = Await Windows.Storage.ApplicationData.Current.LocalFolder.CreateFileAsync(txtCmd.Text.Split(New Char() {" "c}, StringSplitOptions.RemoveEmptyEntries)(1), CreationCollisionOption.OpenIfExists)
                Await ftpClient.DownloadFileAsync(Await file.OpenStreamForWriteAsync, Filename)
                Exit Sub

            End If

            If txtCmd.Text.Equals("PWD") Then

                logger.Logs.Clear()
                Await ftpClient.GetPresentWorkingDirectoryAsync
                Exit Sub

            End If

            If txtCmd.Text.Equals("LIST") Then

                logger.Logs.Clear()
                Await ftpClient.GetDirectoryListingAsync
                Exit Sub

            End If

            If txtCmd.Text.StartsWith("CWD") Then

                logger.Logs.Clear()
                Await ftpClient.ChangeWorkingDirectoryAsync(txtCmd.Text.Split(New Char() {" "c}, StringSplitOptions.RemoveEmptyEntries)(1))
                Exit Sub

            End If

            If txtCmd.Text.Equals("QUIT") Then

                logger.Logs.Clear()
                Await ftpClient.DisconnectAsync
                Exit Sub

            End If

        End Sub

        Private Sub ftpClient_FtpFileDownloadFailed(ByVal sender As Object, ByVal e As FtpFileTransferFailedEventArgs)

            'e.LocalFileStream.Close
            'e.LocalFileStream.Dispose
            logger.AddLog("download failed")

        End Sub

        Private Sub ftpClient_FtpFileUploadFailed(ByVal sender As Object, ByVal e As FtpFileTransferFailedEventArgs)

            'e.LocalFileStream.Close
            'e.LocalFileStream.Dispose
            logger.AddLog("upload failed")

        End Sub

        Private Sub ftpClient_FtpFileDownloadSucceeded(ByVal sender As Object, ByVal e As FtpFileTransferEventArgs)

            'e.LocalFileStream.Close
            'e.LocalFileStream.Dispose
            logger.AddLog("download done")

        End Sub

        Private Sub ftpClient_FtpFileUploadSucceeded(ByVal sender As Object, ByVal e As FtpFileTransferEventArgs)

            'e.LocalFileStream.Close
            'e.LocalFileStream.Dispose
            logger.AddLog("upload done")

        End Sub

        Private Async Sub ftpClient_FtpConnected(ByVal sender As Object, ByVal e As EventArgs)

            Await (TryCast(sender, FtpClient)).AuthenticateAsync

        End Sub

        Private Sub ftpClient_FtpPresentWorkingDirectoryReceived(ByVal sender As Object, ByVal e As FtpPresentWorkingDirectoryEventArgs)

            logger.AddLog(String.Format("Present working directory is: {0}", e.PresentWorkingDirectory))

        End Sub

        Private Sub ftpClient_FtpDirectoryChangedSucceded(ByVal sender As Object, ByVal e As FtpDirectoryChangedEventArgs)

            logger.AddLog(String.Format("Directory {0} change succeeded", e.RemoteDirectory))

        End Sub

        Private Sub ftpClient_FtpDirectoryChangedFailed(ByVal sender As Object, ByVal e As FtpDirectoryChangedEventArgs)

            logger.AddLog("Directory change failed")

        End Sub

        Private Sub ftpClient_FtpAuthenticationFailed(ByVal sender As Object, ByVal e As EventArgs)

            logger.AddLog("Authentication failed")

        End Sub

        Private Sub ftpClient_FtpAuthenticationSucceeded(ByVal sender As Object, ByVal e As EventArgs)

            logger.AddLog("Authentication succeeded")

        End Sub

    End Class

End Namespace
